/**
Demonstrates how the stack grows *down*
as we call more subroutines.

On my Linux machine, this prints:
On call 1, argument is at 0xbffff1e0
On call 2, argument is at 0xbffff1c0
On call 3, argument is at 0xbffff1a0
On call 4, argument is at 0xbffff180
On call 5, argument is at 0xbffff160
On call 6, argument is at 0xbffff140
On call 7, argument is at 0xbffff120
On call 8, argument is at 0xbffff100
On call 9, argument is at 0xbffff0e0
On call 10, argument is at 0xbffff0c0

Orion Sky Lawlor, olawlor@acm.org, 2005/09/28 (Public Domain)
*/

#include <iostream>
using namespace std;

#ifdef __i386__
/* Little subroutine; returns %ebp, the x86 frame pointer */
__asm__(
"get_frame_pointer:\n"
"   mov %ebp,%eax\n"
"   ret\n"
);
#endif
extern "C" void *get_frame_pointer(void);

void foo_recursive(int nTimes) {
	cout<<"On call "<<nTimes<<", argument is at "<<&nTimes<<endl;
	if (nTimes>=10) {
		cout<<"Innermost call: stack trace"<<endl;
		void *ptr=get_frame_pointer();
		while (ptr!=0) {
			cout<<"Pointer="<<ptr<<endl;
			ptr=*(void **)ptr;
		}
		return;
	}
	foo_recursive(nTimes+1);
}

int main() {
	foo_recursive(1);
}
